// MBGLView.cpp : implementation file
//

#include "stdafx.h"
#include<extgl.h>
#include<time.h>
#include<vcg/Matrix44.h>
using namespace vcg;
#include<vcg/CIMsg.h>

//#include<GL/gl.h>
//#include<GL/glu.h>
#include "Moebius.h"
#include "MBDoc.h"
#include "MBView.h"
#include "MBGLView.h"
#include <il/il.h>
#include <il/ilu.h>
#include <il/ilut.h>
  

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMBGLView

IMPLEMENT_DYNCREATE(CMBGLView, CView)

CMBGLView::CMBGLView()
{
 m_hrc=0;
 m_pDC=0;
 m_bCaptured=false;
}

CMBGLView::~CMBGLView()
{
}

BEGIN_MESSAGE_MAP(CMBGLView, CView)
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
//	ON_COMMAND(ID_HELP_OPENGL, A)
ON_COMMAND(ID_HELP_OPENGL, OnHelpOpengl)
END_MESSAGE_MAP()


// CMBGLView drawing

void CMBGLView::OnDraw(CDC* pDC)
{	
	CMBDoc * pd = GetDocument();
	SetGL();
	if(pd->m.Empty()) pd->m.Generate();

		// Gestione dell'animazione
	float AngularVelocity = 120; // degree per sec;
	float ElapsedSecs = float(clock())/CLOCKS_PER_SEC ;
	float CurAngleDeg = AngularVelocity * ElapsedSecs;
	float CurAngleRad = CurAngleDeg/180.0f*3.14159265f;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glInit();
	glMatrixMode(GL_PROJECTION);	
	glLoadIdentity();
	gluPerspective(60,aspect,.4,25);

	// Inizializzazione della Modelview Matrix
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();	
  
	// World To Camera Transformation
	gluLookAt(0,0,10,0,0,0,0,1,0);
	
	// Apply the trackball
	glMultMatrix(m_matRot);
  
	// disegnamo il background come una cubemap.
	cm.DrawEnvCube(m_matRot);
	 	
	// moto di precessione: una rotazione il cui asse ruota intorno all'asse z
	glRotated( 10,cos(ToRad(-45+CurAngleDeg*.5)),sin(ToRad(-45+CurAngleDeg*.5)),0);  

	// Texture anello. una texture rossa con un finto riflesso phong mappata con
	// la tecnica dello spherical environment mapping. Cercate di vedere dove non funge.
	// provate ad applicarla sulla pallina al posto della cube map degli uffizi.
	// provate poi a sostuire la spheremap finto phong con una cubemap finto phong 
	// (che vi disegnate ovviamente da soli)

	glEnable(GL_TEXTURE_2D);	
	glBindTexture(GL_TEXTURE_2D,tiRing);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glTexGeni(GL_S,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);
	glTexGeni(GL_T,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);
	
	/* Altro settaggio texture per giocare.
 	glTexGeni(GL_S,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
	glTexGeni(GL_T,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
	float planevs[4]={1.0,0,0,0};
	float planevt[4]={0,1.0,0,0}; 
	glTexGenfv(GL_S,GL_OBJECT_PLANE,planevs);
	glTexGenfv(GL_T,GL_OBJECT_PLANE,planevt); 
	*/

	pd->m.Ring.Draw<true,true>();
	
	// Disegnamo sulla pallina in multitexture 
	// texture 1: usando le coordinate di texture, 
	//            colore rosso con la banda blu, 
	//            modulato con il bianco normalmente shaded
  // texture 2: coordinate texture generate automaticamente
	//            cubemap con gli uffizi in riflessione
	//            modulato con la precedente
	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);

	glActiveTexture(GL_TEXTURE0);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
  glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
	glBindTexture(GL_TEXTURE_2D,tiBall);
	
	glActiveTexture(GL_TEXTURE1);
	glEnable(GL_TEXTURE_CUBE_MAP);	
	glBindTexture(GL_TEXTURE_CUBE_MAP,cm.ti);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glEnable(GL_TEXTURE_GEN_R);
	glTexGeni(GL_S,GL_TEXTURE_GEN_MODE,GL_REFLECTION_MAP);
	glTexGeni(GL_T,GL_TEXTURE_GEN_MODE,GL_REFLECTION_MAP);
	glTexGeni(GL_R,GL_TEXTURE_GEN_MODE,GL_REFLECTION_MAP);
	
	// per far si che la riflessione si muova sulla pallina si deve mettere 
	// l'inversa della matrice di rotazione della trackball 
	// nella matrice di texture
	// Se non capite perche'ci vuole l'inversa chiedetemelo a lezione.
	glMatrixMode(GL_TEXTURE);
	glLoadIdentity();
	Matrix44f inv=m_matRot; inv.Invert();
	glMultMatrix(inv);
	glMatrixMode(GL_MODELVIEW);
 
  // Movimento della pallina
	// Ancora un po'arrangiato. La classe MoebiusStrip::Pos 
	// rappresenta una posizione sull anello. 
	// Andrebbe fatto meglio, aggiornandolo in un posto solo (e non nella view)

	MoebiusStrip::Pos pp;
	pp.CurSide=0;
	pp.ThetaDeg=CurAngleDeg/3;
	//mette il sistema di riferimento con l'origine sulla sup dell'anello
	// z verso l'alto rispetto alla sup dell'anello
	// y avanti
	// x asse di rotolamento della pallina
	pd->m.Transform(pp);
	glTranslatef(pd->RollingSphereRadius,0,0);
	
	// Rotolamento della pallina.  
	glRotatef(pp.ThetaDeg*pd->m.Radius,0,0,1);
	
	// alla fine si disegna la pallina
	pd->RollingSphere.Draw<true,true>();
	
	glDisable(GL_TEXTURE_CUBE_MAP);	
	glActiveTexture(GL_TEXTURE0);
	
	// Calcolo e stampa fps
	fps.Add();
	CString buf;
	buf.Format("Fps %4.2f",fps.LastFPS());
	cf.OrthoPrint(buf, Point3f(10,10,0));

	SwapBuffers(m_pDC->GetSafeHdc());
	
}


// CMBGLView diagnostics

#ifdef _DEBUG
void CMBGLView::AssertValid() const
{
	CView::AssertValid();
}

void CMBGLView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
// CMBView diagnostics

CMBDoc* CMBGLView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMBDoc)));
	return (CMBDoc*)m_pDocument;
}
#endif //_DEBUG


// CMBGLView message handlers
void CMBGLView::glInit()
{
	// Abilita il la possibilita' di cambiare il alcune componenti colore del 
	// materiale tramite un semplice glcolor, anzich fare glMaterial(...)
	glColorMaterial(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE);
	glEnable(GL_COLOR_MATERIAL);

	// Abilita il calcolo dell'illuminazione
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	// anche le normali attraversano la pipeline, quindi devono essere  
	// rinormalizzate, prima del calcolo dell'illuminazione, altrimenti 
	// il calcolo dell'illuminazione viene sbagliato.
	glEnable(GL_NORMALIZE); 
	
	// Abilita il test sullo zbuffer e quindi l'eliminazione delle 
	// superfici nascoste
	glEnable(GL_DEPTH_TEST); 	

	glEnable(GL_CULL_FACE);
	glCullFace(GL_BACK);
	
}


BOOL CMBGLView::SetupPixelFormat( CDC * pDC )
{
    static PIXELFORMATDESCRIPTOR pfd = 
	 {
		sizeof(PIXELFORMATDESCRIPTOR),  //  size of this pfd
			1,                     // version number
			PFD_DRAW_TO_WINDOW |   // support window
			PFD_SUPPORT_OPENGL |   // support OpenGL
			PFD_DOUBLEBUFFER,      // double buffered
			PFD_TYPE_RGBA,         // RGBA type 
			24,                    // 24-bit color depth 
			0, 0, 0, 0, 0, 0,      // color bits ignored
			0,                     // no alpha buffer
			0,                     // shift bit ignored
			0,                     // no accumulation buffer
			0, 0, 0, 0,            // accum bits ignored
			32,                    // 32-bit z-buffer
			0,                     // no stencil buffer
			0,                     // no auxiliary buffer
			PFD_MAIN_PLANE,        // main layer
			0,                     // reserved
			0, 0, 0                // layer masks ignored
	 };
    int pixelformat;

    if ( (pixelformat = ChoosePixelFormat(pDC->GetSafeHdc(), &pfd)) == 0 )
    {
        AfxMessageBox("ChoosePixelFormat failed");
	    return FALSE;
    }

    if (SetPixelFormat(pDC->GetSafeHdc(), pixelformat, &pfd) == FALSE)
    {
        AfxMessageBox("SetPixelFormat failed");
	    return FALSE;
    }

    return TRUE;
}


BOOL CMBGLView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext)
{
  if( ! CView::Create(lpszClassName, lpszWindowName, dwStyle, 
		rect, pParentWnd, nID, pContext)) 	return false;

  m_pDC = new CClientDC(this);
  ASSERT(m_pDC != NULL);

  // Setta il pixel format
  if (!SetupPixelFormat(m_pDC)) return FALSE;
  // Crea e setta il contesto OPENGL
  m_hrc = wglCreateContext(m_pDC->GetSafeHdc());
  if(m_hrc==NULL){
		AfxMessageBox("OpenGL contest fail");
		return FALSE;
	}
  return TRUE;
}

void CMBGLView::OnDestroy()
{
  CView::OnDestroy();
  SetGL();
  glFinish();
  wglMakeCurrent(NULL,  NULL);
  if (m_hrc) ::wglDeleteContext(m_hrc);
  if (m_pDC) delete m_pDC;
}

BOOL CMBGLView::OnEraseBkgnd(CDC* pDC)
{
  return TRUE;
}

void CMBGLView::OnSize(UINT nType, int cx, int cy)
{
	if(SetGL()){
	glMatrixMode (GL_PROJECTION);   
	glLoadIdentity ();
	aspect=(float)cx/(float)cy;
	glViewport (0, 0, (GLsizei) cx, (GLsizei) cy); 
	m_tb.Resize( cx,cy );
	}
}

void CMBGLView::OnInitialUpdate()
{
	CView::OnInitialUpdate();
  CMBDoc * pd = GetDocument();
	SetGL();
	extgl_Initialize();
	ilInit();
	iluInit();
	ilutRenderer(ILUT_OPENGL);
	tiRing=ilutGLLoadImage("spheremap2.jpg");
	ilutGLBuildMipmaps();
	//tiBall=ilutGLLoadImage("ball.png");
	//ilutGLBuildMipmaps();
	
	ILuint ili;
	ilGenImages(1,&ili);
	ilBindImage(ili);
	ilLoad(IL_TYPE_UNKNOWN ,"ball.png");
	glGenTextures(1,&tiBall);
	glBindTexture(GL_TEXTURE_2D,tiBall);
	glTexImage2D(GL_TEXTURE_2D,0,3,64,64,0,GL_RGB,GL_UNSIGNED_BYTE,ilGetData());
	gluBuild2DMipmaps(GL_TEXTURE_2D,3,64,64,GL_RGB,GL_UNSIGNED_BYTE,ilGetData());

	cm.Load("uffizi.jpg");
	CRect rc;
	GetClientRect(&rc);
	m_tb.Init(rc.right,rc.bottom);
	m_matRot.SetIdentity();
	cf.Init("rial",20);
}

void CMBGLView::OnLButtonDown(UINT nFlags, CPoint point)
{
	if(!m_bCaptured)
	{
		m_tb.MouseDown( point.x, point.y, 0 );
		SetCapture();
		m_bCaptured = TRUE;
	}

	CView::OnLButtonDown(nFlags, point);
}

void CMBGLView::OnLButtonUp(UINT nFlags, CPoint point)
{
	if(m_bCaptured)
	{
		m_tb.MouseUp(point.x,point.y);
		ReleaseCapture();
		m_bCaptured = FALSE;
	}

	CView::OnLButtonUp(nFlags, point);
}

void CMBGLView::OnMouseMove(UINT nFlags, CPoint point)
{
	if(m_bCaptured)
	{
		m_tb.CalcRotMatrix( m_matRot, point.x, point.y );
		Invalidate();
	}	
	CView::OnMouseMove(nFlags, point);
}


void CMBGLView::OnHelpOpengl()
{
	const char *msg=(char *)glGetString(GL_EXTENSIONS);
	AfxMessageBox(msg);
}

