#pragma once


// CMBGLView view
#include<GL/gl.h>
#include<GL/glu.h>
#include<vcg/CITrackball.h>
#include<vcg/CICubeMap.h>
#include<vcg/CIGLFont.h>
#include<vcg/CIFPS.h>

class CMBGLView : public CView
{
	DECLARE_DYNCREATE(CMBGLView)

protected:
	CMBGLView();           // protected constructor used by dynamic creation
	virtual ~CMBGLView();
public:
  CMBDoc* GetDocument() const;
  CClientDC	*m_pDC;	// DC della finestra
  HGLRC		 m_hrc;	// Contesto OpenGL
  float aspect;
	GLuint tiRing;
	GLuint tiBall;
	GLuint tiCubeMapSky;

	// Gestione trackball
	CITrackball m_tb;
	Matrix44f m_matRot;
  bool m_bCaptured;
	CICubeMap cm;
	CIGLFont cf;
	CIFPS fps;


// Operations
public:
	BOOL SetupPixelFormat( CDC * pDC );
  void glInit();
	inline BOOL SetGL()
  {
    if(!(m_pDC && m_hrc)) {
		TRACE("Failed SetGL\n");
		return false;
    }
		
    if(!wglMakeCurrent(m_pDC->GetSafeHdc(), m_hrc)){
		AfxMessageBox("GlMakeCurrent Error");
		return FALSE;
    }
   return TRUE;
  }



public:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	virtual void OnInitialUpdate();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
//	afx_msg void A();
	afx_msg void OnHelpOpengl();
};
#ifndef _DEBUG  // debug version in MBView.cpp
inline CMBDoc* CMBGLView::GetDocument() const
   { return reinterpret_cast<CMBDoc*>(m_pDocument); }
#endif


