#pragma once
#include <vector>
#include <vcg/Point3.h>
#include <vcg/Matrix44.h>
#include <vcg/CIMesh.h>



class MoebiusStrip
{
public:
	class Block
	{
	 public:
	 };
 
 class Pos
 {
 public:
	 float ThetaDeg;
	 int CurSide;
 };
 
 // sposta la posizione di dist lungo la sup dell'anello
 void Move(Pos &p, float DistDeg);

 // genera la trasformazione opengl che porta il sistema di riferimento 
 // con l'origine sulla superfice del nastro, z up y front e x destra;
 void Transform(const Pos &p);
  
	MoebiusStrip(void);
	~MoebiusStrip(void);
	void Generate();
	CIMesh Ring;
	// parameters

	int SideNum;  // 2 = strip, 3 triangular section ecc.
	float Turns;  // espresso in 2pi / SideNum. 
  float Radius; // del centro della strip
	float InnerRadius;  // largezza lato strip;
	float FilletRatio;  // lato "verticale"
  int BlockNum;  // in quanti pezzetti  diviso un anello.
	float StartTwistDeg;
	int StepNum;
	
	bool Empty() const {return Ring.Empty();}
	void Clear();
	void GenerateRing(const vector<Point3f> &SectionP, const vector<Point3f> &SectionN);
	void GenerateBlock();
  void GenerateSection( vector<Point3f> &SP,  vector<Point3f> &SN, int side ,float radius, float filletratio);

};
