// Piccola classe per calcolare i fps
//
// basta aggiungere un'oggetto FPS per view, e chiamare fps.Add() per ogni rendering.
// fps.GetFPS() ritorna i frame per sec calcolati sulla la media degli ultimi <AVGNUM> tempi.

class CIFPS
{
public:
	enum {
		AVGNUM=10,  // Si mediano gli ultimi AVG tempi
		GRAN=500    // si aggiorna la media degli ultimi tempi solo ogni GRAN msec (per evitare flickering)
	};
	int times[AVGNUM];
	int pos;
	float lastavg;
	int lastShowTime;
	int lasttime;

	CIFPS()
	{
		pos=0;
		lastavg=100;
		lasttime=0;
		lastShowTime=0;
		for(int i=0;i<AVGNUM;++i) times[i]=0;
	}
	// ritorna la media de
	float LastFPS() const
	{
		return 1000.0f/lastavg;
	}
		
	// return the current FPS;
	float LastFrameTime() const {
		return lastavg;
	}
	
	void Add()
	{
		int newtime=clock();
		AddFrameTime(newtime-lasttime);
		lasttime=newtime;
	}

	void AddFrameTime(int LastFrameTime) // in msec;
	{
		//TRACE("FPS: Add %i\n",LastFrameTime);
		times[pos%AVGNUM]=LastFrameTime;
		++pos;
		if(lastShowTime<clock()-GRAN) 
		{
			lastShowTime=clock();
			float sum=0;
			for(int i=0;i<AVGNUM;++i) 
				sum+=times[i];
			lastavg = float(sum)/float(min(int(AVGNUM),pos));
			//TRACE("Updated lastavg %f\n",lastavg);					
		}
	}
};
